# ./addons/eventscripts/weaponmenu/weaponmenu.py
# Say command: !weaponmenu

import cfglib
import cmdlib
import es
import langlib
import playerlib
import weaponlib

from path import path

from cheappopup import *

popup = CheapPopup()


info = es.AddonInfo()
info.name     = 'WeaponMenu'
info.version  = '1'
info.url      = 'http://addons.eventscripts.com/addons/view/cheappopup'
info.basename = 'weaponmenu'
info.author   = 'SuperDave'

addonpath = path(__file__).dirname()

###

ini = cfglib.AddonINI(addonpath.joinpath(info.basename + '_languages.ini'))

ini.addGroup('main menu header')
ini.addValueToGroup('main menu header', 'en', 'Select category:')

ini.addGroup('main menu smg')
ini.addValueToGroup('main menu smg', 'en', 'Sub-machine guns')

ini.addGroup('main menu rifle')
ini.addValueToGroup('main menu rifle', 'en', 'Rifles')

ini.addGroup('main menu shotgun')
ini.addValueToGroup('main menu shotgun', 'en', 'Shotguns')

ini.addGroup('main menu machinegun')
ini.addValueToGroup('main menu machinegun', 'en', 'Machineguns')

ini.addGroup('main menu pistol')
ini.addValueToGroup('main menu pistol', 'en', 'Pistols')

ini.addGroup('main menu grenade')
ini.addValueToGroup('main menu grenade', 'en', 'Grenades')

ini.addGroup('weapon_deagle')
ini.addValueToGroup('weapon_deagle', 'en', 'Night Hawk .50c (deagle)')

ini.addGroup('weapon_ak47')
ini.addValueToGroup('weapon_ak47', 'en', 'CV-47 (ak47)')

ini.addGroup('weapon_scout')
ini.addValueToGroup('weapon_scout', 'en', 'Schmidt scout (scout)')

ini.addGroup('weapon_aug')
ini.addValueToGroup('weapon_aug', 'en', 'Bullpup (aug)')

ini.addGroup('weapon_g3sg1')
ini.addValueToGroup('weapon_g3sg1', 'en', 'D3/AU-1 (g3sg1)')

ini.addGroup('weapon_galil')
ini.addValueToGroup('weapon_galil', 'en', 'IDF defender (galil)')

ini.addGroup('weapon_famas')
ini.addValueToGroup('weapon_famas', 'en', 'Clarion 5.56 (famas)')

ini.addGroup('weapon_m4a1')
ini.addValueToGroup('weapon_m4a1', 'en', 'Maverick M4A1 carbine (m4a1)')

ini.addGroup('weapon_sg552')
ini.addValueToGroup('weapon_sg552', 'en', 'Krieg 552 (sg552)')

ini.addGroup('weapon_sg550')
ini.addValueToGroup('weapon_sg550', 'en', 'Krieg 550 commando (sg550)')

ini.addGroup('weapon_m249')
ini.addValueToGroup('weapon_m249', 'en', 'M249 (m249)')

ini.addGroup('weapon_awp')
ini.addValueToGroup('weapon_awp', 'en', 'Magnum sniper rifle (awp)')

ini.addGroup('weapon_tmp')
ini.addValueToGroup('weapon_tmp', 'en', 'Schmidt machine pistol (tmp)')

ini.addGroup('weapon_mp5navy')
ini.addValueToGroup('weapon_mp5navy', 'en', 'KM sub-machine gun (mp5navy)')

ini.addGroup('weapon_glock')
ini.addValueToGroup('weapon_glock', 'en', '9x19mm sidearm (glock)')

ini.addGroup('weapon_elite')
ini.addValueToGroup('weapon_elite', 'en', '.40 dual elites (elite)')

ini.addGroup('weapon_m3')
ini.addValueToGroup('weapon_m3', 'en', 'Leone 12 gauge shotgun (m3)')

ini.addGroup('weapon_xm1014')
ini.addValueToGroup('weapon_xm1014', 'en', 'Leone YG1265 auto shotgun (xm1014)')

ini.addGroup('weapon_mac10')
ini.addValueToGroup('weapon_mac10', 'en', 'Ingram MAC-10 (mac10)')

ini.addGroup('weapon_ump45')
ini.addValueToGroup('weapon_ump45', 'en', 'KM UMP45 (ump45)')

ini.addGroup('weapon_usp')
ini.addValueToGroup('weapon_usp', 'en', 'KM .45 tactical (usp)')

ini.addGroup('weapon_p228')
ini.addValueToGroup('weapon_p228', 'en', '228 compact (p228)')

ini.addGroup('weapon_fiveseven')
ini.addValueToGroup('weapon_fiveseven', 'en', 'ES five-seven (fiveseven)')

ini.addGroup('weapon_p90')
ini.addValueToGroup('weapon_p90', 'en', 'ES C90 (p90)')

ini.addGroup('weapon_hegrenade')
ini.addValueToGroup('weapon_hegrenade', 'en', 'HE grenade (hegrenade)')

ini.addGroup('weapon_smokegrenade')
ini.addValueToGroup('weapon_smokegrenade', 'en', 'Smoke grenade (smokegrenade)')

ini.addGroup('weapon_flashbang')
ini.addValueToGroup('weapon_flashbang', 'en', 'Flashbang (flashbang)')

ini.addGroup('weapon_knife')
ini.addValueToGroup('weapon_knife', 'en', 'Knife (knife)')

ini.write()

lang_text = langlib.Strings(ini)

###

MAIN_MENU_ITEMS = ('smg', 'rifle', 'shotgun', 'machinegun', 'pistol', 'grenade')

def mainMenu(userid, args=None):
   lang = playerlib.getPlayer(userid).getLanguage()
   selections = SelectionDict()
   for item in MAIN_MENU_ITEMS:
      selections[lang_text('main menu ' + item, lang=lang)] = item
   popup.sendSelectionMenu(userid, selections, mainMenuSelect, lang_text('main menu header', lang=lang))

cmdlib.registerSayCommand('!weaponmenu', mainMenu, 'Say  !weaponmenu  to pick from a list of weapons')


def mainMenuSelect(userid, item):
   if item is None: # We don't care about "no selections"
      return
   lang = playerlib.getPlayer(userid).getLanguage()
   selections = dict((lang_text(str(weapon), lang=lang), weapon) for weapon in weaponlib.getWeaponList('#' + item))
   popup.sendSelectionMenu(userid, selections, weaponSelect, lang_text('main menu ' + item, lang=lang),
    firstback=mainMenu)


def weaponSelect(userid, item):
   if item is None:
      return
   if item.slot in (1, 2):
      handle = es.getplayerhandle(userid)
      for index in weaponlib.xgetIndexList('#primary' if item.slot == 1 else '#secondary'):
         # Remove the player's weapon if he or she has one
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
            # Silently kill the entity
            es.entitysetvalue(index, 'targetname', 'weaponmenu_kill')
            es.fire(userid, 'weaponmenu_kill', 'Kill')
            break # We found a weapon, so stop looping
   elif '#grenade' in item.tags:
      if es.getplayerprop(userid, item.prop) >= item.maxammo:
         return # Cannot give more grenades than the player can hold
   # Give the weapon
   es.give(userid, str(item))

###

def unload():
   popup.unload()
   cmdlib.unregisterSayCommand('!weaponmenu')